---
 drivers/md/Kconfig                 |    8 ++++++++
 drivers/md/Makefile                |    3 ++-
 drivers/md/persistent-data/Kconfig |    1 +
 3 files changed, 11 insertions(+), 1 deletion(-)

Index: linux-3.1-rc9/drivers/md/Kconfig
===================================================================
--- linux-3.1-rc9.orig/drivers/md/Kconfig
+++ linux-3.1-rc9/drivers/md/Kconfig
@@ -208,6 +208,14 @@ config DM_DEBUG
 
 	  If unsure, say N.
 
+config DM_BUFIO
+       tristate
+       depends on BLK_DEV_DM && EXPERIMENTAL
+       ---help---
+	 This interface allows you to do buffered I/O on a device and acts
+	 as a cache, holding recently-read blocks in memory and performing
+	 delayed writes.
+
 source "drivers/md/persistent-data/Kconfig"
 
 config DM_CRYPT
Index: linux-3.1-rc9/drivers/md/Makefile
===================================================================
--- linux-3.1-rc9.orig/drivers/md/Makefile
+++ linux-3.1-rc9/drivers/md/Makefile
@@ -3,7 +3,7 @@
 #
 
 dm-mod-y	+= dm.o dm-table.o dm-target.o dm-linear.o dm-stripe.o \
-		   dm-ioctl.o dm-io.o dm-kcopyd.o dm-sysfs.o dm-bufio.o
+		   dm-ioctl.o dm-io.o dm-kcopyd.o dm-sysfs.o
 dm-multipath-y	+= dm-path-selector.o dm-mpath.o
 dm-snapshot-y	+= dm-snap.o dm-exception-store.o dm-snap-transient.o \
 		    dm-snap-persistent.o
@@ -28,6 +28,7 @@ obj-$(CONFIG_MD_MULTIPATH)	+= multipath.
 obj-$(CONFIG_MD_FAULTY)		+= faulty.o
 obj-$(CONFIG_BLK_DEV_MD)	+= md-mod.o
 obj-$(CONFIG_BLK_DEV_DM)	+= dm-mod.o
+obj-$(CONFIG_DM_BUFIO)		+= dm-bufio.o
 obj-$(CONFIG_DM_CRYPT)		+= dm-crypt.o
 obj-$(CONFIG_DM_DELAY)		+= dm-delay.o
 obj-$(CONFIG_DM_FLAKEY)		+= dm-flakey.o
Index: linux-3.1-rc9/drivers/md/persistent-data/Kconfig
===================================================================
--- linux-3.1-rc9.orig/drivers/md/persistent-data/Kconfig
+++ linux-3.1-rc9/drivers/md/persistent-data/Kconfig
@@ -2,6 +2,7 @@ config DM_PERSISTENT_DATA
        tristate
        depends on BLK_DEV_DM && EXPERIMENTAL
        select LIBCRC32C
+       select DM_BUFIO
        ---help---
 	 Library providing immutable on-disk data structure support for
 	 device-mapper targets such as the thin provisioning target.
